unit Debug_UnitTest;

{*******************************************************}
{                                                       }
{       Demoonlit Delphi eXtreme Programming            }
{       Testing Framework                               }
{                                                       }
{       2001 YT                                         }
{                                                       }
{*******************************************************}

(*
	RubyUnit(̖{)̐^ł.
	ETestFailed𖳎OɎw肵Ă.

	g

	VKŃR\[AvP[VI.
	R\[ɏo͂Ȃ{$APPTYPE CONSOLE}͏Ă.
	TestCaseeXgNXhāApublishedɃeXg\bh.
	e`FbN Assert(eXgpr֐(...)) ōs.
	program ...eXgNX`... begin  end. ́̂ƂɁA
	eXgNXЂƂ̂Ƃ TestRunner.Run(eXgNX.Suite)
	 TestRunner.Run(TestSuite.Group([eXgNX1.Suite, ...])) Ə.
	ŃeXgs.
	ʂ́AOutputDebugStringɂďo͂̂ŁA
	IDE[Ctrl]+[Alt]+[E]ŊmFł܂.

	TestRunner.QuietModeTrueɂƏo͗ʂ.
	TestRunner.OutputForwofStdOutɂƕWo͂ɏo.

	---- XPg ----

	program XXXTest;

	uses
		Debug_MemCheck,
		Debug_UnitTest,
		SysUtils;

	type
		TestXXXX = class(TestCase)
		published
			procedure Test1;
		end;

	procedure TestXXXX.Test1;
	begin
		Assert(Equals(1 + 1, 2))
	end;

	begin
		TestRunner.Run(TestXXXX.Suite)
	end.

*)

{$IFDEF VER140}
	{$WARN SYMBOL_PLATFORM OFF}
{$ENDIF}

interface

uses
	Windows, SysUtils, SysConst {$IFDEF VER140}, Variants {$ENDIF};

type
	ProcName = ShortString;

	Observer = class
	protected
		procedure Notify(const Message: String); virtual; abstract;
	end;

	Test = class; {forward}
	TestCase = class; {forward}

	TestFailure = class
	private
		FAt: ProcName;
		FErr: String;
	public
		constructor Create(const AErr: String; const AAt: ProcName);
		property At: ProcName read FAt;
		property Err: String read FErr;
	end;

	TestFailures = array of TestFailure;

	ResultState = (rsSafe, rsFailed, rsError);

	TestResult = class
	private
		FView: Observer;
		FFailures: TestFailures;
		FErrors: TestFailures;
		FState: ResultState;
	public
		constructor Create(AView: Observer);
		destructor Destroy; override;
		procedure Run(ATest: TestCase);
		procedure AddFailure(AFailure: TestFailure);
		procedure AddError(AFailure: TestFailure);
		function Succed: Boolean;
		property Failures: TestFailures read FFailures;
		property Errors: TestFailures read FErrors;
	end;

	Test = class
	public
		procedure Run(AResult: TestResult); virtual; abstract;
		function CountTestCases: Cardinal; virtual; abstract;
	end;

	TestSuite = class(Test)
	private
		FCases: array of Test;
	public
		destructor Destroy; override;
		procedure Run(AResult: TestResult); override;
		procedure AddTest(ATest: Test);
		function CountTestCases: Cardinal; override;
		class function Group(const Tests: array of Test): TestSuite;
	end;

{$TYPEINFO ON}
	TestCase = class(Test)
	private
		FTestName: ProcName;
	protected
		procedure Setup; virtual;
		procedure TearDown; virtual;
		procedure RunBare(AResult: TestResult);
	public
		constructor Create(ATestName: ProcName); virtual;
		procedure Run(AResult: TestResult); override;
		property TestName: ProcName read FTestName;
		function CountTestCases: Cardinal; override;
		class function Suite: TestSuite;
	end;
{$TYPEINFO OFF}

	WinOutputFor = (wofStdOut, wofDebugString);

	TTestRunner = class(Observer)
	private
		FBuffer: String;
		FQuietMode: Boolean;
		FOutputFor: WinOutputFor;
	protected
		function Write(const Message: String): TTestRunner;
		procedure Line;
		procedure Notify(const Message: String); override;
	public
		property QuietMode: Boolean read FQuietMode write FQuietMode;
		property OutputFor: WinOutputFor read FOutputFor write FOutputFor;
		constructor Create;
		procedure Run(ATest: Test);
	end;

	ETestFailed = class(EAssertionFailed);
	ETestError = class(Exception);

function TestRunner: TTestRunner;

{eXgpr֐}
function Equals(const V1, V2: Variant): Boolean;
function Assigned(const V: Pointer): Boolean;
function InstanceOf(Obj: TObject; Cla: TClass): Boolean;

implementation

{Singleton}

var
	_TestRunner: TTestRunner;

function TestRunner: TTestRunner;
begin
	if _TestRunner = nil then
		_TestRunner := TTestRunner.Create;

	Result := _TestRunner;
end;

{Assert ̎s󂯂ėO𓊂鎞Ɏg}
var
	ProcessingProcedure: ProcName;
	AssertionMessage: String;

function Equals(const V1, V2: Variant): Boolean;
begin
	if VarType(V1) <> VarType(V2) then
		raise ETestError.Create(SInvalidVarCast);

	Result := V1 = V2;
	AssertionMessage := 'excepted: <' + String(V1) + '> ' +
					'but was: <' + String(V2) + '>'
end;

function Assigned(const V: Pointer): Boolean;
begin
	Result := System.Assigned(V);
	AssertionMessage := 'must be assigned but was nil';
end;

function InstanceOf(Obj: TObject; Cla: TClass): Boolean;
begin
	if Obj = nil then
	begin
		AssertionMessage := 'excepted: ' + Cla.ClassName + ' instance ' +
						'but was: <nil>';
		Result := False;
	end
	else
	begin
		Result := Obj.InheritsFrom(Cla);
		AssertionMessage := 'excepted: ' + Cla.ClassName + ' instance ' +
						'but was: ' + Obj.ClassName
	end
end;

{internal}

procedure AssertErrorHandler(const Message, FileName: string;
				LineNumber: Integer; ErrorAddr: Pointer);
var
	S: string;
begin
	if (Message <> '') and (Message <> 'Assertion failure') then
		S := Message
	else
		S := AssertionMessage;

	raise ETestFailed.Create(ExtractFileName(FileName) +
					' :' + IntToStr(LineNumber) +
					' :in ' + ProcessingProcedure + ': ' + S);
end;

{RTTI Tă\bh̗. ǓĂ邱Ƃ͊m}
function MethodIndexedAddress(EAX: TClass; EDX: Cardinal): Pointer; register;
asm
				PUSH    ESI
				PUSH    EDI
				inc     EDX;                    {̎ dec 邩}
				XOR     ECX,ECX
				XOR     EDI,EDI
				JMP     @@haveVMT
@@outer:                                { upper 16 bits of ECX are 0 !  }
				MOV     EAX,[EAX]
@@haveVMT:
				MOV     ESI,[EAX].vmtMethodTable
				TEST    ESI,ESI
				JE      @@parent
				MOV     DI,[ESI]                { EDI := method count           }
				ADD     ESI,2
@@inner:                                { upper 16 bits of ECX are 0 !  }
				jmp     @@cmpChar
@@cont:                                 { upper 16 bits of ECX are 0 !  }
				MOV     CX,[ESI]                { fetch length of method desc   }
				ADD     ESI,ECX                 { point ESI to next method      }
				DEC     EDI
				JNZ     @@inner
@@parent:
				MOV     EAX,[EAX].vmtParent     { fetch parent vmt              }
				TEST    EAX,EAX
				JNE     @@outer
				JMP     @@exit                  { return NIL                    }
@@cmpChar:
				dec     EDX;
				jne     @@Cont;
				MOV     EAX,[ESI+2]             { found it }
@@exit:
				POP     EDI
				POP     ESI
end;

{ TestFailure }

constructor TestFailure.Create(const AErr: String; const AAt: ProcName);
begin
	inherited Create;
	FErr := AErr;
	FAt := AAt;
end;

{ TestResult }

procedure TestResult.AddError(AFailure: TestFailure);
begin
	FState := rsError;

	SetLength(FErrors, Length(FErrors) + 1);
	FErrors[High(FErrors)] := AFailure;
end;

procedure TestResult.AddFailure(AFailure: TestFailure);
begin
	FState := rsFailed;

	SetLength(FFailures, Length(FFailures) + 1);
	FFailures[High(FFailures)] := AFailure;
end;

constructor TestResult.Create(AView: Observer);
begin
	inherited Create;
	FView := AView;
end;

destructor TestResult.Destroy;
var
	I: Integer;
begin
	for I := Low(FFailures) to High(FFailures) do FFailures[I].Free;
	for I := Low(FErrors) to High(FErrors) do FErrors[I].Free;

	inherited;
end;

procedure TestResult.Run(ATest: TestCase);
const
	S: array[ResultState] of String = ('.', 'F', 'E');
begin
	ProcessingProcedure := ATest.ClassName + '.' + ATest.TestName;
	AssertionMessage := SAssertionFailed;
	FState := rsSafe;

	ATest.RunBare(Self);

	FView.Notify(ProcessingProcedure + ' ' + S[FState]);
end;

function TestResult.Succed: Boolean;
begin
	Result := Length(Failures) + Length(Errors) = 0
end;

{ TestSuite }

procedure TestSuite.AddTest(ATest: Test);
begin
	SetLength(FCases, Length(FCases) + 1);
	FCases[High(FCases)] := ATest
end;

function TestSuite.CountTestCases: Cardinal;
var
	I: Integer;
begin
	Result := 0;
	for I := Low(FCases) to High(FCases) do
		Inc(Result, FCases[I].CountTestCases);
end;

destructor TestSuite.Destroy;
var
	I: Integer;
begin
	for I := Low(FCases) to High(FCases) do FCases[I].Free;
	inherited;
end;

class function TestSuite.Group(const Tests: array of Test): TestSuite;
var
	I: Integer;
begin
	Result := TestSuite.Create;
	for I := Low(Tests) to High(Tests) do
		Result.AddTest(Tests[I]);
end;

procedure TestSuite.Run(AResult: TestResult);
var
	I: Integer;
begin
	for I := Low(FCases) to High(FCases) do
		FCases[I].Run(AResult)
end;

{ TestCase }

function TestCase.CountTestCases: Cardinal;
begin
	Result := 1
end;

constructor TestCase.Create(ATestName: ProcName);
begin
	inherited Create;
	FTestName := ATestName
end;

procedure TestCase.Run(AResult: TestResult);
begin
	AResult.Run(Self)
end;

procedure TestCase.RunBare(AResult: TestResult);
type
	Proc = procedure of object;
var
	P: Pointer;
	Method: TMethod;
	F: TestFailure;
begin
	Setup;
	P := MethodAddress(FTestName);
	if System.Assigned(P) then
	begin
		Method.Code := P;
		Method.Data := Self;
		try
			Proc(Method);
		except
		on E: ETestFailed do
		begin
			F := TestFailure.Create(E.Message, TestName);
			AResult.AddFailure(F);
		end;
		on E: Exception do
		begin
			F := TestFailure.Create(
							'in ' + ProcessingProcedure + ': ' +
							E.Message + ' (' + E.ClassName + ')', TestName);
			AResult.AddError(F);
		end;
		end;
	end;
	TearDown;
end;

procedure TestCase.Setup;
begin
end;

class function TestCase.Suite: TestSuite;
var
	I: Cardinal;
	P: Pointer;
begin
	Result := TestSuite.Create;

	for I := 0 to 65535 do
	begin
		P := MethodIndexedAddress(Self, I); {NX\bh Self ̓NXQ}
		if not System.Assigned(P) then Break;

		Result.AddTest(Create(MethodName(P)));
	end;
end;

procedure TestCase.TearDown;
begin
end;

{ TestRunner }

constructor TTestRunner.Create;
begin
	inherited Create;

	if (DebugHook = 0) and IsConsole then
		FOutputFor := wofStdOut
	else
		FOutputFor := wofDebugString;
end;

procedure TTestRunner.Line;
begin
	if FOutputFor = wofStdOut then
		WriteLn(FBuffer)
	else
		OutputDebugString(PChar(FBuffer));

	FBuffer := ''
end;

procedure TTestRunner.Notify(const Message: String);
begin
	if QuietMode then
		Write(Copy(Message, Length(Message), 1))
	else
		Write(Message).Line;
end;

procedure TTestRunner.Run(ATest: Test);

	procedure Report(Log: TestFailures);
	var
		I: Integer;
	begin
		for I := Low(Log) to High(Log) do
			Write('  ' + Log[I].Err).Line;
	end;

var
	R: TestResult;
	TestStartTime: DWORD;
	Count, FCount, ECount: Cardinal;
begin
	R := TestResult.Create(Self);
	try
		TestStartTime := GetTickCount;

		ATest.Run(R);

		if QuietMode then Line;

		Write('Time: ' + FloatToStrF(
						(GetTickCount - TestStartTime) / 1000, ffFixed, 4, 2)).Line;

		Count := ATest.CountTestCases;
		FCount := Length(R.Failures);
		ECount := Length(R.Errors);

		if FCount > 0 then Write('FAILURES!!!').Line;
		if ECount > 0 then Write('ERRORS!!!').Line;

		Write('Test Results:').Line;
		Write('  Run: ' + IntToStr(Count) +
						' Failures: ' + IntToStr(FCount) +
						' Error: ' + IntToStr(ECount)).Line;

		if R.Succed then
			Write('OK.').Line
		else
		begin
			if Length(R.Failures) > 0 then
			begin
				Write('Failures: ' + IntToStr(FCount)).Line;
				Report(R.Failures);
			end;
			if Length(R.Errors) > 0 then
			begin
				Write('Errors: ' + IntToStr(ECount)).Line;
				Report(R.Errors);
			end
		end
	finally
		R.Free;
		ATest.Free
	end;
	if (FOutputFor = wofStdOut) and (DebugHook <> 0) then ReadLn;
end;

function TTestRunner.Write(const Message: String): TTestRunner;
begin
	FBuffer := FBuffer + Message;
	Result := Self;
end;

initialization

	AssertErrorProc := AssertErrorHandler;

finalization

	_TestRunner.Free;

end.

